#include <stdio.h>
#include <errno.h>

/* writes remaining data from buffer */
int _flushbuf(FILE *f)
{
  _chkabort();
  if (!f) {
    errno = EBADF;
    return (EOF);
  }
  if (!f->bufsize)
    f->bufsize = (f->flags&_UNBUF) ? 1 : BUFSIZ;
  if (!f->base)
    return (0);

  if (f->flags&_WRITE) {
    long len=f->bufsize-f->count;
    if (_write(f->filehandle,f->base,len) != len)
      return (EOF);
  }
  else {
    errno = EBADF;
    return (EOF);
  }

  f->pointer = f->base;
  f->count = 0;
  f->flags &= ~(_READ|_WRITE);
  return (0);
}
